<template lang="pug">
loader(:loading="true", title="Building visualization...")
  .q-ma-md
    q-breadcrumbs
      q-breadcrumbs-el(icon="home", to="/")
      q-breadcrumbs-el(label="Infrastructure", icon="settings")

    .text-h4.q-pt-md Infrastructure

    q-chip
      q-avatar(color="primary", text-color="white")
        q-spinner(v-if="totalUsers == null")
        div(v-else) {{ totalUsers }}
      span users
    q-chip
      q-avatar(color="primary", text-color="white")
        q-spinner(v-if="totalWhitelistedUsers === null")
        div(v-else) {{ totalWhitelistedUsers }}
      span whitelisted users
      q-btn.q-ml-sm.text-caption(
        @click="handleRequestEditWhitelist",
        style="margin-right: -0.45em",
        color="primary",
        round,
        dense,
        text-color="white",
        icon="edit"
      )
    q-chip
      q-avatar(color="primary", text-color="white")
        q-spinner(v-if="totalMeetings === null")
        div(v-else) {{ totalMeetings }}
      span meetings

    .text-h5.q-py-md Current Usage

    q-card.q-my-md(
      flat,
      bordered,
      v-for="(vm, index) of scheduling",
      :key="index"
    )
      q-card-section.q-pa-none(horizontal)
        q-card-section.q-pa-none.row.items-center.justify-center(
          style="width: 3rem"
        )
          .vert.text-grey-6.text-center
            span {{ vmname(index) }}
              br
              div (Capacity: {{ vm.capacity }})
        q-separator(vertical)
        q-card-section.fit.row.items-stretch.content-stretch.q-col-gutter-xs
          q-card-section.col-4(
            v-for="(sensor, name) of vm.sensors",
            :key="name"
          )
            q-card.q-pa-xs(
              flat,
              bordered,
              v-bind:class="{ red: isError(sensorMeeting(name), sensor) == 2, green: isError(sensorMeeting(name), sensor) == 0, orange: isError(sensorMeeting(name), sensor) == 1 }"
            )
              q-card-section.q-pa-xs
                q-chip.float-right {{ sensorNumber(name) }}
                strong.text-no-wrap.ellipsis {{ getMeeting(sensorMeeting(name), sensor).topic }}
                .text-caption {{ sensorMeeting(name) }}
                span.text-grey-6
                  q-icon.q-mr-xs(name="history")
                  span running for {{ runningFor(sensor.startTime) }}
                span.text-grey-6.float-right
                  span {{ getVersion(sensorMeeting(name), sensorNumber(name), sensor) }}
                  q-icon.q-ml-xs(name="build")
                .text-red-5(
                  outline,
                  dense,
                  icon="warning",
                  :v-if="isError(sensorMeeting(name), sensor) > 0"
                ) {{ isErrorMsg(sensorMeeting(name), sensor) }}

          q-card-section.col-4(
            v-for="i in vm.capacity - (vm.sensors ? Object.keys(vm.sensors).length : 0)",
            :key="i"
          )
            q-card.fit.bg-grey-2(flat)
              q-card-section

    .text-h5.q-py-md Scheduled Usage

    //- div meetings that are ready to be Scheduled (visualise overlap (max Capacity required))
    q-skeleton(v-if="!chartDone", height="300px")
    line-graph(
      v-if="chartDone",
      :chartData="chartData",
      :options="chartOptions",
      style="height: 300px",
      :plugins="['annotation']"
    )

    .text-h5.q-py-md Transcode Queue
    .text-grey-6(v-if="Object.keys(processing.recordings).length === 0") Nothing in the queue
    q-list(v-else, separator, bordered)
      q-item(v-for="(recording, key) in allRecordings", :key="key")
        q-item-section
          q-item-label {{ meetingTopicFromFile(recording.filePath) }} ({{ meetingFromFile(recording.filePath).sensor }})
          q-item-label(subtitle) Submitted {{ fromNow(recording.created) }}

    q-dialog(v-model="showEditWhitelistDialog")
      q-card(style="max-height: 35rem; min-width: 30rem")
        q-card-section
          EditWhitelist(
            :whitelist="whitelist",
            :requestAddUserWithEmail="addNewUserToWhitelist",
            :requestDeleteUserWithEmail="deleteUserFromWhitelist"
          )
</template>

<script>
import { db } from '@/db';
import moment from "moment";
import Loader from "@/components/Loader.vue";
import LineGraph from "@/components/LineGraph.vue";
import EditWhitelist from "@/components/EditWhitelist.vue";

export default {
  name: "Admin",
  props: {},
  data: function () {
    return {
      chartDone: false,
      scheduling: null,
      meetings: null,
      whitelist: null,
      processing_orig: {},
      showEditWhitelistDialog: false,
      // scheduling: {
      //   TEST_SERVER: {
      //     capacity: 6,
      //     sensors: {
      //       "96418317858-1": {
      //         password: "",
      //         startTime: "2020-09-22T11:30:00.000Z",
      //         uid: "zoom:Qvo9I8yoS8uVeowquYTjlA",
      //       },
      //       "96418317858-2": {
      //         password: "",
      //         startTime: "2020-09-22T11:30:00.000Z",
      //         uid: "zoom:Qvo9I8yoS8uVeowquYTjlA",
      //       },
      //     },
      //   },
      // },
      // processing_orig: {
      // recordings : {
      //   "CPOl7I2ll+oCEAE=" : {
      //     "created" : "2020-06-23T06:17:52.151Z",
      //     "fileBucket" : "zoombot.appspot.com",
      //     "filePath" : "zoom:Qvo9I8yoS8uVeowquYTjlA/96418317858/ZoomSensor_1-1591856118682/double_click_to_convert_02.meetingrec"
      //   }
      // }
      // },
    };
  },
  watch: {
    chartData: {
      handler: function () {
        this.chartDone = true;
      },
    },
  },
  computed: {
    processing: function () {
      if (this.processing_orig.recordings) return this.processing_orig;
      else return { recordings: {} };
    },
    chartOptions: function () {
      return {
        maintainAspectRatio: false,
        plugins: {
          zoom: {
            pan: {
              // enabled:true
            },
          },
        },
        elements: {
          point: {
            radius: 0,
          },
        },
        scales: {
          yAxes: [
            {
              beginAtZero: true,
              stacked: false,
              ticks: {
                stepSize: 1,
                suggestedMin: 0,
                suggestedMax: this.totalCapacity,
              },
            },
          ],
          xAxes: [
            {
              beginAtZero: false,
              type: "time",
              distribution: "series",

              time: {
                unit: "day",
              },
            },
          ],
        },
      };
    },
    totalCapacity: function () {
      if (this.scheduling != null) {
        let total = 0;
        for (let k in this.scheduling) {
          total += this.scheduling[k].capacity;
        }
        return total;
      } else return 0;
    },
    chartData: function () {
      if (this.meetings == null) return;

      const past = this.getDataForMeetings(this.meetingsInPast(true));
      const future = this.getDataForMeetings(this.meetingsInPast(false));

      const capacity = [
        {
          x: past[0].x,
          y: this.totalCapacity,
        },
        {
          x:
            future.length !== 0
              ? Math.max(past[past.length - 1].x, future[future.length - 1].x)
              : past[past.length - 1].x,
          y: this.totalCapacity,
        },
      ];

      return {
        labels: ["Predicted Capacity"],
        datasets: [
          {
            label: "Capacity",
            data: capacity,
            borderColor: "red",
            borderDash: [5, 5],
            borderWidth: 1,
            fill: false,
            order: 0,
            spanGaps: true,
          },
          {
            label: "In Past",
            data: past,
            fill: false,
            order: 2,
            spanGaps: true,
          },
          {
            label: "In Future",
            data: future,
            fill: false,
            borderColor: "deepskyblue",
            order: 1,
            spanGaps: true,
          },
        ],
      };
    },
    future: function () {
      return [];
    },
    totalMeetings: function () {
      let total = 0;
      if (!this.meetings) return null;
      for (let m in this.meetings) {
        total += Object.keys(this.meetings[m]).length;
      }
      return total;
    },
    totalUsers: function () {
      if (this.meetings != null) return Object.keys(this.meetings).length;
      else return null;
    },
    totalWhitelistedUsers() {
      if (this.whitelist !== null) return Object.keys(this.whitelist).length;
      return null;
    },
    totalStorage: function () {
      return "?";
    },
    allRecordings() {
      return this.processing.recordings;
    },
  },
  methods: {
    getDataForMeetings: function (meetings) {
      const timeToSensorCount = {};
      for (let meeting of meetings) {
        for (
          let increment = moment(meeting.startTime);
          increment < moment(meeting.endTime);
          increment += 1800000
        ) {
          const timeStamp = moment(increment / 1000).valueOf();
          if (!(timeStamp in timeToSensorCount))
            timeToSensorCount[timeStamp] = parseInt(meeting.noOfBreakoutRooms);
          else {
            timeToSensorCount[timeStamp] += parseInt(meeting.noOfBreakoutRooms);
          }
        }
      }

      const data = [];
      for (let timeStamp in timeToSensorCount) {
        data.push({
          x: timeStamp,
          y: timeToSensorCount[timeStamp],
        });
      }

      data.sort((a, b) => {
        return a.x - b.x;
      });

      return data.map(m => ({
        x: moment.unix(m.x),
        y: m.y,
      }));
    },
    meetingsInPast: function (past) {
      const meetings = [];
      for (let userId in this.meetings) {
        for (let meetingId in this.meetings[userId]) {
          const meeting = this.meetings[userId][meetingId];
          if (past && meeting.scheduled) {
            meetings.push(meeting);
          } else if (!past && meeting.scheduled === undefined) {
            meetings.push(meeting);
          }
        }
      }

      return meetings;
    },
    getRandomInt() {
      return Math.floor(Math.random() * (50 - 5 + 1)) + 5;
    },
    fromNow: function (time) {
      return moment(time).fromNow();
    },
    meetingFromFile: function (file) {
      let m = file.split("/");
      return {
        meeting: this.meetings[m[0]][m[1]],
        uid: m[0],
        sensor: m[2].split("_")[1].split("-")[0],
        room: m[2].split("-")[1],
      };
    },
    meetingTopicFromFile: function (file) {
      const meeting = this.meetingFromFile(file);
      return (meeting.meeting) ? meeting.meeting.topic : '[Meeting deleted or changed]';
    },
    vmname: function (name) {
      return name.split("_").join(".");
    },
    sensorNumber: function (name) {
      return name.split("-")[1];
    },
    sensorMeeting: function (name) {
      return name.split("-")[0];
    },
    runningFor: function (time) {
      // console.log(moment(time).fromNow(false));
      return moment(time).fromNow(true);
    },
    isRecording: function (name) {
      name == "";
      return false;
    },
    isError: function (meeting, sensor) {
      // Flag error (running but meeting ended, meeting not ended, but stopped (last seen))
      let diff = moment(sensor.lastSeen).diff(moment(), "minutes", false);
      if (diff < -2) return 1;

      let m = this.getMeeting(meeting, sensor);
      if (!m) return 0;
      if (m.actualEndTime) {
        let diff2 = moment(m.actualEndTime)
          .utc()
          .diff(moment().utc(), "minutes", true);
        if (diff2 < 2) return 2;
      }

      return 0;
    },
    isErrorMsg: function (meeting, sensor) {
      let code = this.isError(meeting, sensor);
      // console.log(sensor);
      // Flag error (running but meeting ended, meeting not ended, but stopped (last seen))
      if (code == 1) {
        let diff = moment().diff(moment(sensor.lastSeen), "minutes", true);
        return `Lost contact for ${diff} min`;
      }

      if (code == 2) return "Meeting closed";

      return "";
    },
    getMeeting: function (meeting, bot) {
      if (!this.meetings) return { topic: "" };
      return this.meetings[bot.uid][meeting];
    },
    getVersion: function (meeting, sensorId, bot) {
      if (!this.meetings) return "";
      return (
        (this.meetings[bot.uid][meeting][`ZoomSensor_${sensorId}`] &&
          this.meetings[bot.uid][meeting][`ZoomSensor_${sensorId}`].version) ||
        this.meetings[bot.uid][meeting].version
      );
    },
    handleRequestEditWhitelist() {
      this.showEditWhitelistDialog = true;
    },
    async addNewUserToWhitelist(email) {
      console.log(email);
      console.log(this.whitelist);
      await this.$firebaseRefs.whitelist.set([...this.whitelist, email]);
    },
    async deleteUserFromWhitelist(email) {
      const indexOfEmail = this.whitelist.indexOf(email);
      await this.$firebaseRefs.whitelist.set(
        this.whitelist.filter((_, index) => index !== indexOfEmail),
      );
    },
  },
  firebase: {
    meetings: db.ref("meetings"),
    scheduling: db.ref("scheduling"),
    processing_orig: db.ref("processing"),
    whitelist: db.ref("whitelist"),
  },
  components: {
    Loader,
    LineGraph,
    EditWhitelist,
  },
};
</script>

<style>
.red {
  border-color: red !important;
}

.orange {
  border-color: orange !important;
}

.green {
  border-color: green !important;
}

.vert {
  -webkit-transform: rotate(90deg);
  transform: rotate(90deg);
}

.recording {
  background: rgba(255, 82, 82, 1);
  border-radius: 50%;
  margin: 10px;
  height: 10px;
  width: 10px;

  box-shadow: 0 0 0 0 rgba(255, 82, 82, 1);
  transform: scale(1);
  animation: pulse 2s infinite;
}

@keyframes pulse {
  0% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 rgba(255, 82, 82, 0.7);
  }

  70% {
    transform: scale(1);
    box-shadow: 0 0 0 10px rgba(255, 82, 82, 0);
  }

  100% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 rgba(255, 82, 82, 0);
  }
}
</style>
